*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\Free\\FREEVIEW.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function Main()
*+               Static Function FileOpen()
*+               Static Function FileSave()
*+               Static Function FileSaveAs()
*+               Static Function FullScreen()
*+               Static Function NextFS()
*+               Static Function NEXT()
*+               Static Function Zoom()
*+               Static Function PictInfo()
*+               Static Function Rotate()
*+               Static Function PaintWindow()
*+               Static Function MsgAbout()
*+               Static Function cFileTime()
*+               Static Function cFileExt()
*+               Static Function Putfile2()
*+               Function DoGoto()
*+               Function IsWinNT()
*+               Function CURDRIVE()
*+               Static Function FilePrint()
*+
*+    Reformatted by Click! 2.05.30 on May-8-2020 at 12:08 am
*+
*+--------------------------------------------------------------------

/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2010 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * FreeImage.dll should present to use this sample
 * http://freeimage.sourceforge.net/
 *
 * Copyright 2003-2015 Grigory Filatov <gfilatov@inbox.ru>
*/

#ifdef Use_Extendet
ANNOUNCE RDDSYS
#include "minigui.ch"
#include "winprint.ch"
#ELSE
#include "FreeImage.ch"
#include "HMG.CH"
#ENDIF

#xcommand ON KEY SPACE [ OF <parent> ] ACTION <action> ;
= > ;
        _DefineHotKey( < "parent" >, 0, VK_SPACE, < { action } > )

#xcommand ON KEY GRAYPLUS [ OF <parent> ] ACTION <action> ;
= > ;
        _DefineHotKey( < "parent" >, 0, VK_ADD, < { action } > )

#xcommand ON KEY GRAYMINUS [ OF <parent> ] ACTION <action> ;
= > ;
        _DefineHotKey( < "parent" >, 0, VK_SUBTRACT, < { action } > )

#xtranslate END IMAGELIST => //

#define PROGRAM 'FreeImage Viewer Lite'
#define VERSION ' version 1.6'
#define COPYRIGHT ' 2003-2015 Grigory Filatov'

#define MsgAlert( c ) MsgInfo( c, "Attention" )
#define CLR_DEFAULT 0xff000000

STATIC handle, nWidth, nHeight, cFile := "", nKoef := 1, aFiles := {}, nItem := 1, nLoadTime := 0, cSaveFile

MEMVAR nScrWidth, nScrHeight
MEMVAR nLen, nWidthOrig, nHeightOrig
MEMVAR _HMG_SYSDATA

*+--------------------------------------------------------------------
*+
*+    Function Main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Main( fname )

LOCAL nLen        := 0, aRect := GetDesktopArea()
PRIVATE nScrWidth := aRect[ 3 ] - aRect[ 1 ], nScrHeight := aRect[ 4 ] - aRect[ 2 ]

   DEFAULT fname := "FreeView.jpg"

   IF !FILE( 'FreeImage.Dll' )
      MsgAlert( "Can't found the FreeImage.Dll" )
      RETURN NIL
   ENDIF

   FREE_Initialise()

   cFile := fname
   aFiles := DIRECTORY( "*.JPG" )
   AEVAL( DIRECTORY( "*.JPEG" ), { | e | AADD( aFiles, e ) } )
   AEVAL( DIRECTORY( "*.PNG" ), { | e | AADD( aFiles, e ) } )
   AEVAL( DIRECTORY( "*.BMP" ), { | e | AADD( aFiles, e ) } )
   AEVAL( DIRECTORY( "*.TIF" ), { | e | AADD( aFiles, e ) } )
   AEVAL( DIRECTORY( "*.PSD" ), { | e | AADD( aFiles, e ) } )
   AEVAL( DIRECTORY( "*.ICO" ), { | e | AADD( aFiles, e ) } )
   nLen := LEN( aFiles )
   nItem := ASCAN( aFiles, { | e | UPPER( e[ 1 ] ) = UPPER( cFile ) } )

   SET CENTURY ON
   SET DATE GERMAN

   DEFINE WINDOW Form_Main ;
              AT 0, 0 ;
              WIDTH 520 HEIGHT 354 ;
              TITLE PROGRAM ;
              MAIN ;
              ICON 'IMAGE' ;
              ON INIT IF( fname <> "FreeView.jpg", FileOpen( fname, .F. ), ( handle := FREE_Load( FIF_JPEG, fname, JPEG_DEFAULT ), ;
              nWidth := FREE_GetWidth( handle ), nHeight := FREE_GetHeight( handle ), ;
              Form_Main.StatusBar.Item( 1 ) := hb_ntos( nWidth ) + " x " + hb_ntos( nHeight ), ;
              Form_Main.StatusBar.Item( 2 ) := hb_ntos( nItem ) + "/" + hb_ntos( nLen ), ;
              Form_Main.StatusBar.Item( 3 ) := STR( nKoef * 100, 4 ) + " %", ;
              Form_Main.StatusBar.Item( 4 ) := LTRIM( STR( filesize( fname ) / 1024 ) ) + " KB", ;
              Form_Main.StatusBar.Item( 5 ) := DTOC( filedate( fname ) ) + " / " + cfiletime( fname ), ;
              Form_Main.Width := nWidth + GetBorderWidth() + 4, ;
              Form_Main.Height := nHeight + GetTitleHeight() + 64, ;
              PaintWindow() ) ) ;
              ON PAINT PaintWindow() ;
              ON RELEASE FREE_Deinitialise() ;
              FONT 'MS Sans Serif' SIZE 9

      DEFINE MAIN MENU

         DEFINE POPUP "&File"
            MENUITEM "&Open" + CHR( 9 ) + " Ctrl+O" ACTION FileOpen()
            SEPARATOR
            MENUITEM "&Save" + CHR( 9 ) + " Ctrl+S" ACTION FileSave()
            MENUITEM "Save &as..." + CHR( 9 ) + "Ctrl+A" ACTION FileSaveAs()
            SEPARATOR
#ifdef Use_Extendet
            MENUITEM "&Print" + CHR( 9 ) + " Ctrl+P" ACTION FilePrint()
            SEPARATOR
            MENUITEM "E&xit" + CHR( 9 ) + " Esc" ACTION ReleaseAllWindows()
#else
            MENUITEM "E&xit" + CHR( 9 ) + " Esc" ACTION Form_Main.Release
#ENDIF

         END POPUP

         DEFINE POPUP "&View"
            MENUITEM "&Information" + CHR( 9 ) + " Ctrl+I" ACTION PictInfo()
            SEPARATOR
            MENUITEM "&Full screen" + CHR( 9 ) + " Ctrl+Enter" ACTION FullScreen()
            SEPARATOR
            MENUITEM "&Zoom In" + CHR( 9 ) + " Gray +" ACTION Zoom( 1 )
            MENUITEM "Zoom &Out" + CHR( 9 ) + " Gray -" ACTION Zoom( - 1 )
            MENUITEM "Original &size" + CHR( 9 ) + " Ctrl+H" ACTION Zoom( 0 )
            SEPARATOR
            MENUITEM "Rotate &Left" + CHR( 9 ) + " Ctrl+L" ACTION Rotate( 90 )
            MENUITEM "Rotate &Right" + CHR( 9 ) + " Ctrl+R" ACTION Rotate( - 90 )
         END POPUP

         DEFINE POPUP "&Help"
            MENUITEM "&About" ACTION MsgAbout()
         END POPUP

      END MENU

      ON KEY F12 ACTION Form_Main.Minimize
#ifdef Use_Extendet
      ON KEY ESCAPE ACTION ReleaseAllWindows()
#else
      ON KEY ESCAPE ACTION Form_Main.Release
#endif
      ON KEY CONTROL + RETURN ACTION FullScreen()
      ON KEY CONTROL + O ACTION FileOpen()
      ON KEY CONTROL + S ACTION FileSave()
      ON KEY CONTROL + A ACTION FileSaveAs()
#ifdef Use_Extendet
      ON KEY CONTROL + P ACTION FilePrint()
#ENDIF
      ON KEY CONTROL + I ACTION PictInfo()
      ON KEY CONTROL + L ACTION Rotate( 90 )
      ON KEY CONTROL + R ACTION Rotate( - 90 )
      ON KEY CONTROL + H ACTION Zoom( 0 )

      ON KEY GRAYPLUS ACTION Zoom( 1 )
      ON KEY GRAYMINUS ACTION Zoom( - 1 )

      ON KEY HOME ACTION( nItem := 1, NEXT( 0 ) )
      ON KEY END ACTION( nItem := LEN( aFiles ), NEXT( 0 ) )
      ON KEY BACK ACTION NEXT ( - 1 )
      ON KEY SPACE ACTION NEXT ( 1 )
      ON KEY LEFT ACTION NEXT ( - 1 )
      ON KEY RIGHT ACTION NEXT ( 1 )

      @  8, 336 TEXTBOX Text_1 HEIGHT 20 WIDTH 80 VALUE IIF( EMPTY( nLen ), "", hb_ntos( nItem ) + "/" + hb_ntos( nLen ) ) ON ENTER DoGoto()

#ifdef Use_Extendet
      DEFINE IMAGELIST ImageList_1 ;
                 BUTTONSIZE 24, 24 ;
                 IMAGE { 'tb_24' } ;
                 COLORMASK CLR_DEFAULT ;
                 IMAGECOUNT 19 ;
                 MASK
      END IMAGELIST

      DEFINE TOOLBAREX ToolBar_1 BUTTONSIZE 24, 24 IMAGELIST 'ImageList_1' FLAT BORDER

         BUTTON Button_1 ;
                 PICTUREINDEX 0 ;
                 ADJUST ;
                 TOOLTIP 'Open' ;
                 ACTION FileOpen()

         BUTTON Button_2 ;
                 PICTUREINDEX 3 ;
                 ADJUST ;
                 TOOLTIP 'Save as' ;
                 ACTION FileSaveAs()

         BUTTON Button_3 ;
                 PICTUREINDEX 4 ;
                 ADJUST ;
                 TOOLTIP 'Print' ;
                 ACTION FilePrint() SEPARATOR

         BUTTON Button_4 ;
                 PICTUREINDEX 10 ;
                 ADJUST ;
                 TOOLTIP 'Info' ;
                 ACTION PictInfo()

         BUTTON Button_5 ;
                 PICTUREINDEX 11 ;
                 ADJUST ;
                 TOOLTIP 'Zoom out' ;
                 ACTION Zoom( 1 )

         BUTTON Button_6 ;
                 PICTUREINDEX 12 ;
                 ADJUST ;
                 TOOLTIP 'Zoom in' ;
                 ACTION Zoom( - 1 )

         BUTTON Button_7 ;
                 PICTUREINDEX 15 ;
                 ADJUST ;
                 TOOLTIP 'Rotate Left' ;
                 ACTION Rotate( 90 )

         BUTTON Button_8 ;
                 PICTUREINDEX 16 ;
                 ADJUST ;
                 TOOLTIP 'Rotate Right' ;
                 ACTION Rotate( - 90 ) SEPARATOR

         BUTTON Button_9 ;
                 PICTUREINDEX 13 ;
                 ADJUST ;
                 TOOLTIP 'Previous' ;
                 ACTION NEXT ( - 1 )

         BUTTON Button_10 ;
                 PICTUREINDEX 14 ;
                 ADJUST ;
                 TOOLTIP 'Next' ;
                 ACTION NEXT ( 1 )

      END TOOLBAREX
#ELSE

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50, 50 FLAT BORDER

         BUTTON Button_1 ;
                 CAPTION 'Open' ;
                 TOOLTIP 'Open' ;
                 ACTION FileOpen()

         BUTTON Button_2 ;
                 CAPTION 'Save as' ;
                 TOOLTIP 'Save as' ;
                 ACTION FileSaveAs()

         BUTTON Button_3 ;
                 CAPTION 'Print' ;
                 TOOLTIP 'Print' ;
                 ACTION nil                                           // FilePrint() SEPARATOR

         BUTTON Button_4 ;
                 CAPTION 'Info' ;
                 TOOLTIP 'Info' ;
                 ACTION PictInfo()

         BUTTON Button_5 ;
                 CAPTION 'Zoom out' ;
                 TOOLTIP 'Zoom out' ;
                 ACTION Zoom( 1 )

         BUTTON Button_6 ;
                 CAPTION 'Zoom in' ;
                 TOOLTIP 'Zoom in' ;
                 ACTION Zoom( - 1 )

         BUTTON Button_7 ;
                 CAPTION 'Rotate Left' ;
                 TOOLTIP 'Rotate Left' ;
                 ACTION Rotate( 90 )

         BUTTON Button_8 ;
                 CAPTION 'Rotate Right' ;
                 TOOLTIP 'Rotate Right' ;
                 ACTION Rotate( - 90 ) SEPARATOR

         BUTTON Button_9 ;
                 CAPTION 'Previous' ;
                 TOOLTIP 'press BACK' ;
                 ACTION NEXT ( - 1 )

         BUTTON Button_10 ;
                 CAPTION 'Next' ;
                 TOOLTIP 'press SPACE' ;
                 ACTION NEXT ( 1 )

      END TOOLBAR
#ENDIF

      Form_Main.Button_2.Enabled := !EMPTY( nLen )
      Form_Main.Button_3.Enabled := !EMPTY( nLen )
      Form_Main.Button_4.Enabled := !EMPTY( nLen )
      Form_Main.Button_5.Enabled := !EMPTY( nLen )
      Form_Main.Button_6.Enabled := !EMPTY( nLen )
      Form_Main.Button_7.Enabled := ( nLen > 1 .OR. fname <> "FreeView.jpg" )
      Form_Main.Button_8.Enabled := ( nLen > 1 .OR. fname <> "FreeView.jpg" )
      Form_Main.Button_9.Enabled := ( nLen > 1 )
      Form_Main.Button_10.Enabled := ( nLen > 1 )

      DEFINE STATUSBAR
STATUSITEM "No file loaded" WIDTH 80
STATUSITEM "" WIDTH 60
STATUSITEM "" WIDTH 52 ACTION Zoom( 0 )
STATUSITEM "" WIDTH 80
STATUSITEM "" WIDTH 124
      END STATUSBAR

   END WINDOW

   CENTER WINDOW Form_Main

   ACTIVATE WINDOW Form_Main

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function FileOpen()
*+
*+    Called from ( freeview.prg )   5 - function main()
*+                                   1 - static function next()
*+                                   1 - function dogoto()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FileOpen( fname, lInit )

LOCAL cPath := "\" + CURDIR() + IF( EMPTY( CURDIR() ), "", "\" ), ;
           nLen := LEN( aFiles ), nFormWidth, nFormHeight, nStart

   DEFAULT fname := "", lInit := .T.

   IF EMPTY( fname )
      fname := GetFile( { { "Image files (*.bmp;*.jpg;*.jpeg;*.gif;*.png;*.psd;*.tif;*.ico)", ;
                          "*.bmp;*.jpg;*.jpeg;*.gif;*.png;*.psd;*.tif;*.ico" } }, "Open", cPath )
   ELSE
      fname := IF( AT( '"', fname ) > 0, STRTRAN( fname, '"', '' ), fname )
   ENDIF

   IF !EMPTY( fname ) .AND. FILE( fname )
      IF handle != Nil
         FREE_Unload( handle )
         handle := Nil
      ENDIF
      cFile := fname
      IF lInit
         aFiles := DIRECTORY( "*.JPG" )
         AEVAL( DIRECTORY( "*.JPEG" ), { | e | AADD( aFiles, e ) } )
         AEVAL( DIRECTORY( "*.PNG" ), { | e | AADD( aFiles, e ) } )
         AEVAL( DIRECTORY( "*.BMP" ), { | e | AADD( aFiles, e ) } )
         AEVAL( DIRECTORY( "*.GIF" ), { | e | AADD( aFiles, e ) } )
         AEVAL( DIRECTORY( "*.TIF" ), { | e | AADD( aFiles, e ) } )
         AEVAL( DIRECTORY( "*.PSD" ), { | e | AADD( aFiles, e ) } )
         AEVAL( DIRECTORY( "*.ICO" ), { | e | AADD( aFiles, e ) } )
         nLen := LEN( aFiles )
         nItem := ASCAN( aFiles, { | e | UPPER( e[ 1 ] ) = UPPER( cFileNoPath( cFile ) ) } )
      ENDIF
      nKoef := 1

      nStart := SECONDS()
      handle := FREE_Load( FREE_GetFileType( fname, 0 ), fname, 0 )
      nLoadTime := SECONDS() - nStart

      nWidth := FREE_GetWidth( handle )
      nHeight := FREE_GetHeight( handle )

      DO WHILE.T.
      nFormWidth := ROUND( nWidth * nKoef, 0 ) + GetBorderWidth() + 4
      nFormHeight := ROUND( nHeight * nKoef, 0 ) + GetTitleHeight() + 2 * GetBorderHeight() + GetMenuBarHeight() + IF( IsWinNT(), 60, 56 )
      IF ( nFormWidth <= nScrWidth .AND. nFormHeight <= nScrHeight ) .OR. nKoef < 0.11
         EXIT
      ENDIF
      nKoef -= 0.01
   ENDDO

   Form_Main.Width := IF( nFormWidth < 400, 400, nFormWidth )
   Form_Main.Height := IF( nFormHeight < 100, 100, nFormHeight )

   IF !Form_Main.Button_2.Enabled .OR. lInit
      Form_Main.Button_2.Enabled := .T.
      Form_Main.Button_3.Enabled := .T.
      Form_Main.Button_4.Enabled := .T.
      Form_Main.Button_5.Enabled := .T.
      Form_Main.Button_6.Enabled := .T.
      Form_Main.Button_7.Enabled := ( nLen > 1 .OR. fname <> "FreeView.jpg" )
      Form_Main.Button_8.Enabled := ( nLen > 1 .OR. fname <> "FreeView.jpg" )
      Form_Main.Button_9.Enabled := ( nLen > 1 )
      Form_Main.Button_10.Enabled := ( nLen > 1 )
   ENDIF
   Form_Main.Text_1.Value := hb_ntos( nItem ) + "/" + hb_ntos( nLen )

   Form_Main.Title := cFileNoPath( fname ) + ' - ' + PROGRAM + ;
                                   IF( nKoef # 1, " (Zoom: " + hb_ntos( ROUND( nKoef * nWidth, 0 ) ) + " x " + hb_ntos( ROUND( nKoef * nHeight, 0 ) ) + ")", "" )
   Form_Main.StatusBar.Item( 1 ) := hb_ntos( nWidth ) + " x " + hb_ntos( nHeight )
   Form_Main.StatusBar.Item( 2 ) := hb_ntos( nItem ) + "/" + hb_ntos( nLen )
   Form_Main.StatusBar.Item( 3 ) := STR( nKoef * 100, 4 ) + " %"
   Form_Main.StatusBar.Item( 4 ) := LTRIM( STR( aFiles[ nItem ] [ 2 ] / 1024 ) ) + " KB"
   Form_Main.StatusBar.Item( 5 ) := DTOC( aFiles[ nItem ] [ 3 ] ) + " / " + aFiles[ nItem ] [ 4 ]

   PaintWindow()
   Form_Main.Center
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function FileSave()
*+
*+    Called from ( freeview.prg )   2 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FileSave()

LOCAL cPath := "\" + CURDIR() + IF( EMPTY( CURDIR() ), "", "\" )
LOCAL cExt  := LOWER( cFileExt( cFile ) ), nFif, nFormat, cSaveFile, nIndex

   IF handle == Nil
      RETURN NIL
   ENDIF

   IF cExt == "jpg" .OR. cExt == "jpeg"
      nFif := FIF_JPEG
      nFormat := JPEG_DEFAULT
      nIndex := 2
   ELSEIF cExt == "png"
      nFif := FIF_PNG
      nFormat := PNG_DEFAULT
      nIndex := 3
   ELSE
      nFif := FIF_BMP
      nFormat := BMP_DEFAULT
      nIndex := 1
   ENDIF

   cSaveFile := PutFile2( { { "Bmp files (*.bmp)", "*.bmp" }, { "Jpg files (*.jpg;*.jpeg)", "*.jpg;*.jpeg" }, ;
                            { "Png files (*.png)", "*.png" } }, 'Save...', cPath, .T., @nIndex )

   IF !EMPTY( cSaveFile )
      cSaveFile := IF( AT( ".", cSaveFile ) > 0, cFileNoPath( cSaveFile ), cSaveFile )

      IF .NOT. FREE_Save( nFif, handle, cSaveFile + "." + cExt, nFormat )
         MsgAlert( "Can't save a file" )
      ENDIF
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function FileSaveAs()
*+
*+    Called from ( freeview.prg )   4 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FileSaveAs()

LOCAL cPath := "\" + CURDIR() + IF( EMPTY( CURDIR() ), "", "\" )
LOCAL cExt  := LOWER( cFileExt( cFile ) ), nFif, nFormat, cSaveFile, nIndex

   IF handle == Nil
      RETURN NIL
   ENDIF

   IF cExt == "jpg" .OR. cExt == "jpeg"
      nIndex := 2
   ELSEIF cExt == "png"
      nIndex := 3
   ELSE
      nIndex := 1
   ENDIF
   cSaveFile := PutFile2( { { "Bmp files (*.bmp)", "*.bmp" }, { "Jpg files (*.jpg;*.jpeg)", "*.jpg;*.jpeg" }, ;
                            { "Png files (*.png)", "*.png" } }, 'Save Image As...', cPath, .T., @nIndex )

   IF !EMPTY( cSaveFile )
      IF nIndex == 2
         nFif := FIF_JPEG
         nFormat := JPEG_DEFAULT
         cExt := "jpg"
      ELSEIF nIndex == 3
         nFif := FIF_PNG
         nFormat := PNG_DEFAULT
         cExt := "png"
      ELSE
         nFif := FIF_BMP
         nFormat := BMP_DEFAULT
         cExt := "bmp"
      ENDIF

      cSaveFile := IF( AT( ".", cSaveFile ) > 0, cSaveFile, cSaveFile + "." + cExt )

      IF .NOT. FREE_Save( nFif, handle, cSaveFile, nFormat )
         MsgAlert( "Can't save a file" )
      ENDIF
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function FullScreen()
*+
*+    Called from ( freeview.prg )   2 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FullScreen()

LOCAL nMode  := IF( nWidth < nScrWidth .AND. nHeight < nScrHeight, 0, 2 )
PRIVATE nLen := LEN( aFiles ), nWidthOrig := nWidth, nHeightOrig := nHeight

   cSaveFile := GetTempFolder() + "\" + cFileNoExt( cFile ) + ".bmp"

   DEFINE WINDOW Form_2 AT 0, 0 ;
              WIDTH GetDesktopWidth() HEIGHT GetDesktopHeight() ;
              CHILD TOPMOST NOSIZE NOCAPTION ;
              ON INIT( FREE_Save( FIF_BMP, handle, cSaveFile, BMP_DEFAULT ), ;
              DrawPicture( GetFormHandle( "Form_2" ), cSaveFile, nMode ), ;
              Form_2.Label_1.Value := cFile + " [ " + hb_ntos( nItem ) + " / " + hb_ntos( nLen ) + " ]" ) ;
              ON RELEASE( FERASE( cSaveFile ), ;
              Form_Main.Width := ROUND( nWidth * nKoef, 0 ) + GetBorderWidth() + 4, ;
              Form_Main.Height := ROUND( nHeight * nKoef, 0 ) + GetTitleHeight() + GetBorderHeight() + GetMenuBarHeight() + 60, ;
              IF( Form_Main.Width < 400, Form_Main.Width := 400, ), ;
              IF( Form_Main.Height < 100, Form_Main.Height := 100, ), Form_Main.Center ) ;
              BACKCOLOR BLACK

      ON KEY ESCAPE ACTION Form_2.Release
      ON KEY RETURN ACTION Form_2.Release
      ON KEY CONTROL + RETURN ACTION Form_2.Release
      ON KEY LEFT ACTION NextFS( - 1 )
      ON KEY RIGHT ACTION NextFS( 1 )
      ON KEY UP ACTION( nItem := 1, NextFS( 0 ) )
      ON KEY DOWN ACTION( nItem := LEN( aFiles ), NextFS( 0 ) )
      ON KEY BACK ACTION NextFS( - 1 )
      ON KEY SPACE ACTION NextFS( 1 )

      @  0,  0 LABEL Label_1 VALUE "" ;
              WIDTH nScrWidth HEIGHT 16 ;
              FONT 'Tahoma' SIZE 9 ;
              FONTCOLOR GREEN TRANSPARENT
   END WINDOW

   ACTIVATE WINDOW Form_2

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function NextFS()
*+
*+    Called from ( freeview.prg )   6 - static function fullscreen()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION NextFS( nOp )

LOCAL nMode, fname, clone
LOCAL nFormWidth := Form_2.Width, nFormHeight := Form_2.Height, nRatio := nWidth / nHeight, nW, nH

   IF nLen > 1
      FERASE( cSaveFile )
      FREE_Unload( handle )

      IF nOp < 0
         nItem --
         nItem := IF( nItem < 1, nLen, nItem )
      ELSEIF nOp > 0
         nItem ++
         nItem := IF( nItem > nLen, 1, nItem )
      ENDIF

      cFile := aFiles[ nItem ] [ 1 ]
      cSaveFile := GetTempFolder() + "\" + cFileNoExt( cFile ) + ".bmp"

      fname := CurDrive() + ":\" + CURDIR() + IF( EMPTY( CURDIR() ), "", "\" ) + cFile

      handle := FREE_Load( FREE_GetFileType( fname, 0 ), fname, 0 )

      nWidth := FREE_GetWidth( handle )
      nHeight := FREE_GetHeight( handle )

      nMode := IF( nWidth < nScrWidth .AND. nHeight < nScrHeight, 0, 2 )

      IF nWidth > nFormWidth .OR. nHeight > nFormHeight .OR. nWidthOrig >= nFormWidth .OR. nHeightOrig >= nFormHeight
         nW := nFormWidth
         nH := nFormHeight
         IF nRatio >= 1
            nH := ROUND( nHeight * ( 10 * nW / nWidth ) / 10, 0 )
         ELSE
            nW := ROUND( nWidth * ( 10 * nH / nHeight ) / 10, 0 )
         ENDIF
         nWidth := nW
         nHeight := nH
         clone := FREE_Clone( handle )
         FREE_Unload( handle )
         handle := FREE_Rescale( clone, nWidth, nHeight, FILTER_BICUBIC )
         FREE_Unload( clone )
      ENDIF

      FREE_Save( FIF_BMP, handle, cSaveFile, BMP_DEFAULT )

      ERASE WINDOW Form_2
      DrawPicture( GetFormHandle( "Form_2" ), cSaveFile, nMode )

      Form_2.Label_1.Value := cFile + " [ " + hb_ntos( nItem ) + " / " + hb_ntos( nLen ) + " ]"
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function NEXT()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION NEXT ( nOp )

LOCAL nLen := LEN( aFiles )

   IF nLen > 1
      IF nOp < 0
         nItem --
         nItem := IF( nItem < 1, nLen, nItem )
      ELSEIF nOp > 0
         nItem ++
         nItem := IF( nItem > nLen, 1, nItem )
      ENDIF

      FileOpen( aFiles[ nItem ] [ 1 ], .F. )
   ELSE
      Form_Main.Text_1.Value := hb_ntos( nItem ) + "/" + hb_ntos( nLen )
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function Zoom()
*+
*+    Called from ( freeview.prg )  11 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Zoom( nOp )

LOCAL nPictWidth, nPictHeight

   IF handle == Nil
      RETURN NIL
   ENDIF

   IF EMPTY( nOp ) .AND. nKoef == 1
      RETURN NIL
   ENDIF

   IF INT( nKoef * 10 ) # ROUND( nKoef, 1 ) * 10
      nKoef := INT( nKoef * 10 ) / 10
   ELSE
      nKoef := ROUND( nKoef, 1 )
   ENDIF
   IF nOp < 0 .AND. nKoef > 0.11
      nKoef -= 0.1
   ELSEIF nOp > 0 .AND. nKoef < 9.9
      nKoef += 0.1
   ELSE
      nKoef := 1
   ENDIF

   nPictWidth := ROUND( nWidth * nKoef, 0 )
   nPictHeight := ROUND( nHeight * nKoef, 0 )

   Form_Main.Width := nPictWidth + GetBorderWidth() + 4
   Form_Main.Height := nPictHeight + GetTitleHeight() + GetBorderHeight() + GetMenuBarHeight() + 60

   IF Form_Main.Width < 400
      Form_Main.Width := 400
   ENDIF
   IF Form_Main.Height < 100
      Form_Main.Height := 100
   ENDIF

   Form_Main.Title := cFileNoPath( cFile ) + ' - ' + PROGRAM + ;
                                   IF( nKoef # 1, " (Zoom: " + hb_ntos( nPictWidth ) + " x " + hb_ntos( nPictHeight ) + ")", "" )
   Form_Main.StatusBar.Item( 3 ) := STR( nKoef * 100, 4 ) + " %"

   InvalidateRect( Form_Main.Handle, 0 )

   Form_Main.Center

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function PictInfo()
*+
*+    Called from ( freeview.prg )   4 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION PictInfo()

LOCAL cExt   := LOWER( cFileExt( cFile ) )
LOCAL aLabel := {}, cLabel, aText := {}, cText, n

   AADD( aLabel, "File name:" )
   AADD( aLabel, "Folder:" )
   AADD( aLabel, "Compression:" )
   AADD( aLabel, "Original size:" )
   AADD( aLabel, "Disk size:" )
   AADD( aLabel, "Current folder index:" )
   AADD( aLabel, "File date/time:" )
   AADD( aLabel, "Loaded in:" )

   AADD( aText, cFileNoPath( cFile ) )
   AADD( aText, CurDrive() + ":\" + CURDIR() + IF( EMPTY( CURDIR() ), "", "\" ) )
   IF cExt == "jpg"
      AADD( aText, "JPG" )
   ELSEIF cExt == "bmp"
      AADD( aText, "None" )
   ELSEIF cExt == "png"
      AADD( aText, "PNG" )
   ELSEIF cExt == "tif"
      AADD( aText, "TIFF" )
   ELSEIF cExt == "ico"
      AADD( aText, "Windows ICON - None" )
   ENDIF
   AADD( aText, hb_ntos( nWidth ) + " x " + hb_ntos( nHeight ) + " Pixels" )
   AADD( aText, LTRIM( STR( aFiles[ nItem ] [ 2 ] / 1024 ) ) + " KB (" + LTRIM( STR( aFiles[ nItem ] [ 2 ] ) ) + " Bytes)" )
   AADD( aText, hb_ntos( nItem ) + " / " + hb_ntos( LEN( aFiles ) ) )
   AADD( aText, DTOC( aFiles[ nItem ] [ 3 ] ) + " / " + aFiles[ nItem ] [ 4 ] )
   AADD( aText, hb_ntos( INT( nLoadTime * 1000 ) ) + " milliseconds" )

   DEFINE WINDOW Form_Info AT 0, 0 ;
              WIDTH 360 HEIGHT 300 ;
              TITLE PROGRAM + " - Image properties" ;
              CHILD ;
              NOSIZE ;
              NOSYSMENU ;
              ON INIT Form_Info.Button_OK.SetFocus ;
              FONT 'MS Sans Serif' ;
              SIZE 9

      @  8,  8 FRAME Frame_1 ;
              WIDTH 338 ;
              HEIGHT 212

      FOR n := 1 TO LEN( aLabel )
         cLabel := "Label_" + hb_ntos( n )
         @ ( n - 1 ) * 24 + 23, 20 LABEL &cLabel ;
             VALUE aLabel[ n ] ;
             WIDTH 100 HEIGHT 20
      NEXT

      FOR n := 1 TO LEN( aText )
         cText := "Text_" + hb_ntos( n )
         @ ( n - 1 ) * 24 + 21, 134 TEXTBOX &cText ;
             VALUE aText[ n ] ;
             HEIGHT 20 ;
             WIDTH 200 ;
             READONLY
      NEXT

      @ Form_Info.Height - 68 - IF( IsXPThemeActive(), 4, 0 ), Form_Info.Width / 2 - 50 BUTTON Button_OK ;
              CAPTION "OK" ;
              ACTION Form_Info.Release ;
              WIDTH 96 HEIGHT 32

   END WINDOW

   CENTER WINDOW Form_Info

   ACTIVATE WINDOW Form_Info

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function Rotate()
*+
*+    Called from ( freeview.prg )   8 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Rotate( n )

LOCAL new_handle
LOCAL nFormWidth, nFormHeight

   IF handle == Nil
      RETURN NIL
   ENDIF

   IF !( ( new_handle := FREE_RotateClassic( handle, n ) ) == Nil )

      FREE_Unload( handle )
      handle := new_handle

      nWidth := FREE_GetWidth( handle )
      nHeight := FREE_GetHeight( handle )

      nKoef := 1

      DO WHILE.T.
      nFormWidth := ROUND( nWidth * nKoef, 0 ) + GetBorderWidth() + 4
      nFormHeight := ROUND( nHeight * nKoef, 0 ) + GetTitleHeight() + 2 * GetBorderHeight() + GetMenuBarHeight() + IF( IsWinNT(), 60, 56 )
      IF ( nFormWidth <= nScrWidth .AND. nFormHeight <= nScrHeight ) .OR. nKoef < 0.11
         EXIT
      ENDIF
      nKoef -= 0.01
   ENDDO

   Form_Main.Width := IF( nFormWidth < 400, 400, nFormWidth )
   Form_Main.Height := IF( nFormHeight < 100, 100, nFormHeight )

   PaintWindow()
   Form_Main.Center

   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function PaintWindow()
*+
*+    Called from ( freeview.prg )   2 - function main()
*+                                   1 - static function fileopen()
*+                                   1 - static function rotate()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION PaintWindow()

LOCAL pps, hDC

   IF handle == Nil
      RETURN - 1
   ENDIF

   hDC := BeginPaint( Form_Main.Handle, @pps )

   FREE_WinDraw( handle, hDC, 36, 0, ROUND( nHeight * nKoef, 0 ) + 36, ROUND( nWidth * nKoef, 0 ) )

   EndPaint( Form_Main.Handle, pps )

   InvalidateRect( Form_Main.Handle, 0 )

RETURN 0

*+--------------------------------------------------------------------
*+
*+    Static Function MsgAbout()
*+
*+    Called from ( freeview.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION MsgAbout()
RETURN MsgInfo( PadC( PROGRAM + VERSION, 40 ) + CRLF + ;
      PadC( "Copyright " + Chr( 169 ) + COPYRIGHT, 40 ) + CRLF + CRLF + ;
      hb_Compiler() + CRLF + Version() + CRLF + ;
      Left( MiniGuiVersion(), 38 ) + CRLF + ;
      "FreeImage.dll version: " + FREE_GetVersion() + CRLF + CRLF + ;
      PadC( "This program is Freeware!", 40 ), "About..." )
*+--------------------------------------------------------------------
*+
*+    Static Function cFileTime()
*+
*+    Called from ( freeview.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION cFileTime( cFileName )

LOCAL aFiles := DIRECTORY( cFileName )

RETURN IF( LEN( aFiles ) == 1, aFiles[ 1, 4 ], '' )

*+--------------------------------------------------------------------
*+
*+    Static Function cFileExt()
*+
*+    Called from ( freeview.prg )   1 - static function filesave()
*+                                   1 - static function filesaveas()
*+                                   1 - static function pictinfo()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION cFileExt( cPathMask )

LOCAL cExt := ALLTRIM( cFileNoPath( cPathMask ) )
LOCAL n    := RAT( ".", cExt )

RETURN ALLTRIM( IF( n > 0 .AND. LEN( cExt ) > n, RIGHT( cExt, LEN( cExt ) - n ), "" ) )

*+--------------------------------------------------------------------
*+
*+    Static Function Putfile2()
*+
*+    Called from ( freeview.prg )   1 - static function filesave()
*+                                   1 - static function filesaveas()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Putfile2( aFilter, title, cIniFolder, nochangedir, nFilterIndex )

LOCAL c := '', n

   IF aFilter == Nil
      aFilter := {}
   ENDIF

   FOR n := 1 TO LEN( aFilter )
      c += aFilter[ n ] [ 1 ] + CHR( 0 ) + aFilter[ n ] [ 2 ] + CHR( 0 )
   NEXT

RETURN C_PutFile2( c, title, cIniFolder, nochangedir, @nFilterIndex )

*+--------------------------------------------------------------------
*+
*+    Function DoGoto()
*+
*+    Called from ( freeview.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION DoGoto()

LOCAL nLen   := LEN( aFiles )
LOCAL cValue := Form_Main.Text_1.Value
LOCAL nPosi

   nPosi := AT( "/", cValue )
   IF nPosi > 0
      nItem := VAL( SUBSTR( cValue, 1, nPosi - 1 ) )
   ELSE
      nItem := VAL( cValue )
   ENDIF

   IF nLen > 1
      FileOpen( aFiles[ nItem ] [ 1 ], .F. )
   ELSE
      Form_Main.Text_1.Value := hb_ntos( nItem ) + "/" + hb_ntos( nLen )
   ENDIF

   RETURN NIL

#ifdef Use_Extendet
#ELSE

*+--------------------------------------------------------------------
*+
*+    Function IsWinNT()
*+
*+    Called from ( freeview.prg )   1 - static function fileopen()
*+                                   1 - static function rotate()
*+
*+--------------------------------------------------------------------
*+
FUNCTION IsWinNT()

RETURN .T.

*+--------------------------------------------------------------------
*+
*+    Function CURDRIVE()
*+
*+    Called from ( freeview.prg )   1 - static function nextfs()
*+                                   1 - static function pictinfo()
*+
*+--------------------------------------------------------------------
*+
FUNCTION CURDRIVE()

   RETURN DISKNAME()
#ENDIF

#ifdef Use_Extendet

*+--------------------------------------------------------------------
*+
*+    Static Function FilePrint()
*+
*+    Called from ( freeview.prg )   3 - function main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION FilePrint()

LOCAL cTmpFile, nScale := 1 / 3.937, nX, nY, nH, nW

   IF !EMPTY( cFile ) .AND. FILE( cFile )

      INIT PRINTSYS

      SELECT BY DIALOG

      IF HBPRNERROR != 0
         RETURN NIL
      ENDIF

      cTmpFile := GetTempFolder() + "\" + cFileNoExt( cFile ) + ".bmp"
      FREE_Save( FIF_BMP, handle, cTmpFile, BMP_DEFAULT )

      SET UNITS MM                                                    // Sets @... units to milimeters
      SET PAPERSIZE DMPAPER_A4                                        // Sets paper size to A4

      IF nHeight >= nWidth
         SET ORIENTATION PORTRAIT                                     // Sets paper orientation to portrait
         nH := 250
         nW := 170
      ELSE
         SET ORIENTATION LANDSCAPE                                    // Sets paper orientation to landscape
         nH := 170
         nW := 250
      ENDIF

      SET BIN DMBIN_FIRST                                             // Use first bin
      SET QUALITY DMRES_HIGH                                          // Sets print quality to high
      SET COLORMODE DMCOLOR_COLOR // SET PRINT COLOR mode TO COLOR
      SET PREVIEW ON                                                  // Enables print preview
      SET PREVIEW RECT 0, 0, nScrHeight, nScrWidth

      START DOC NAME LEFT( PROGRAM, 9 )
         START PAGE

            DO WHILE .T.

               nX := ROUND( nHeight * nScale, 0 )
               nY := ROUND( nWidth * nScale, 0 )

               IF ( nX <= nH .AND. nY <= nW ) .OR. nScale < 0.15
                  EXIT
               ENDIF

               nScale -= 0.05

            ENDDO

            @ 15, 20 PICTURE cTmpFile SIZE nX, nY         

         END PAGE
      END DOC

      RELEASE PRINTSYS

      FERASE( cTmpFile )

   ENDIF

RETURN NIL

#ENDIF

*+ EOF: FREEVIEW.PRG
